#include <cstdio>

#define MAXM 200000
#define MAXK 10000

struct point
{
	long double x, y, z;
	point() : x(0), y(0), z(0)
	{
	}
	void operator=(const point& a)
	{
		x=a.x; y=a.y; z=a.z;
	}
	void operator-=(const point& a)
	{
		x-=a.x; y-=a.y; z-=a.z;
	}
	void operator+=(const point& a)
	{
		x+=a.x; y+=a.y; z+=a.z;
	}
	void operator*=(int k)
	{
		x*=k; y*=k; z*=k;
	}
	void operator/=(int k)
	{
		x/=k; y/=k; z/=k;
	}
	bool operator==(const point& a)
	{
		return (x==a.x && y==a.y && z==a.z);
	}
};

const point& norm(const point& a, const point& b, const point& c)
{
	static point u,v,r;
	u = b; u -= a;
	v = c; v -= a;
	r.x = u.y*v.z-u.z*v.y;
	r.y = u.z*v.x-u.x*v.z;
	r.z = u.x*v.y-u.y*v.x;
	return r;
}

inline int sign(long double a)
{
	return (a>0 ? 1 : a<0 ? -1 : 0);
}

bool same(const point& p, const point& n, const point& a, const point& b)
{
	static point u,v;
	u = a; u -= p;
	v = b; v -= p;
	return (sign(u.x*n.x+u.y*n.y+u.z*n.z) * sign(v.x*n.x+v.y*n.y+v.z*n.z)) >= 0;
}

point P[MAXK], R[2][MAXK];
point W[MAXM], V[MAXM];
point U[MAXM][3];
point N[MAXM];
point O, A;
int   K[MAXM];
bool  found;

int main()
{
	int D;
	scanf("%d",&D);
	for (int d=0; d<D; d++)
	{
		int M;
		scanf("%d %d",&M,&K[0]);
		for (int k=0; k<K[0]; k++)
		{
			scanf("%lf %lf %lf",&P[k].x,&P[k].y,&P[k].z);
			R[0][k] = P[k];
			if (k<3)
				U[0][k] = P[k];
		}
		W[0] = P[0];
		for (int m=1; m<M; m++)
		{
			scanf("%d",&K[m]);
		  found = false;
			for (int k=0; k<K[m]; k++)
			{
			  scanf("%lf %lf %lf",&R[m%2][k].x,&R[m%2][k].y,&R[m%2][k].z);
				if (k<3)
					U[m][k] = R[m%2][k];
        if (!found)
				{
					bool id = false;
				  for (int j=0; j<K[m-1]; j++)
						if (R[m%2][k]==R[(m+1)%2][j])
						{
							id = true;
							break;
						}
					if (!id)
					{
						V[m-1] = R[m%2][k];
						found = true;
					}
				}
			}
			W[m] = R[m%2][0];
		}
		found = false;
		for (int k=0; k<K[0]; k++)
			if (!found)
  		{
			  bool id = false;
				for (int j=0; j<K[M-1]; j++)
					if (P[k]==R[(M+1)%2][j])
					{
						id = true;
						break;
					}
				if (!id)
				{
					V[M-1] = P[k];
					found = true;
				}
	  	}
		for (int m=0; m<M; m++)
			N[m] = norm(U[m][0],U[m][1],U[m][2]);
		int n;
		scanf("%d",&n);
		for (int i=0; i<n; i++)
		{
			scanf("%lf %lf %lf",&A.x,&A.y,&A.z);
			bool ok = true;
			for (int m=0; m<M; m++)
				if (!same(W[m],N[m],V[m],A))
				{
					ok = false;
					break;
				}
			if (ok)
				printf("TAK\n");
			else
				printf("NIE\n");
		}
		printf("\n");
	}
}

